蓝桥杯Log大侠(线段树单点区间更新)

标题:Log大侠

atm参加了速算训练班,经过刻苦修炼,对以2为底的对数算得飞快,人称Log大侠。

一天,Log大侠的好友 drd 有一些整数序列需要变换,Log大侠正好施展法力...

变换的规则是: 对其某个子序列的每个整数变为: [log_2 (x) + 1]  其中 [] 表示向下取整,就是对每个数字求以2为底的对数,然后取下整。     例如对序列 3 4 2 操作一次后,这个序列会变成 2 3 2。         drd需要知道,每次这样操作后,序列的和是多少。

【输入格式】 第一行两个正整数 n m 。 第二行 n 个数,表示整数序列,都是正数。 接下来 m 行,每行两个数 L R 表示 atm 这次操作的是区间 [L, R],数列序号从1开始。

【输出格式】 输出 m 行,依次表示 atm 每做完一个操作后,整个序列的和。

例如,输入: 3 3 5 6 4 1 2 2 3 1 3

程序应该输出: 10 8 6

【数据范围】 对于 30% 的数据, n, m <= 10^3 对于 100% 的数据, n, m <= 10^5

资源约定: 峰值内存消耗 < 256M CPU消耗  < 1000ms

#include"cstdio"
#include"cmath"
#include"algorithm"
using namespace std;
const int MAXN=100005;
typedef long long LL;
struct node{
    int l,r;
    LL sum;
}segTree[MAXN*3];
int cnt;
void build(int rt,int l,int r)
{
    segTree[rt].l=l;
    segTree[rt].r=r;
    if(l==r)
    {
        scanf("%lld",&segTree[rt].sum);
        if(segTree[rt].sum==1)
        {
            cnt++;//统计数值1的个数 ,方便优化程序
            segTree[rt].sum++;//将所有1均变为2,防止1干扰程序优化
        }
        return ;
    }
    int mid=(l+r)>>1;
    build(rt<<1,l,mid);
    build((rt<<1)|1,mid+1,r);
    segTree[rt].sum=segTree[rt<<1].sum+segTree[(rt<<1)|1].sum;
}

void update(int rt,int l,int r)
{
    if(segTree[rt].l==l&&segTree[rt].r==r&&segTree[rt].sum==2*(r-l+1))    return ;//优化:不超过4轮,不小于2的整数在均变为2 

    if(segTree[rt].l==segTree[rt].r)
    {
        segTree[rt].sum=(LL)(log2(segTree[rt].sum*1.0)+1);
        return ;
    }

    int mid=(segTree[rt].l+segTree[rt].r)>>1;

    if(r<=mid)    update(rt<<1,l,r);
    else if(mid<l)    update((rt<<1)|1,l,r);
    else{
        update(rt<<1,l,mid);
        update((rt<<1)|1,mid+1,r);
    }
    segTree[rt].sum=segTree[rt<<1].sum+segTree[(rt<<1)|1].sum;
}

int main()
{
    int n,m;
    scanf("%d%d",&n,&m);
    build(1,1,n);
    while(m--)
    {
        int x,y;
        scanf("%d%d",&x,&y);
        update(1,x,y);
        printf("%lld\n",segTree[1].sum-cnt);
    }
}
时间: 2024-10-06 18:29:24

蓝桥杯Log大侠(线段树单点区间更新)的相关文章

HDU 4027 Can you answer these queries?(线段树,区间更新,区间查询)

题目 线段树 简单题意: 区间(单点?)更新,区间求和 更新是区间内的数开根号并向下取整 这道题不用延迟操作 //注意: //1:查询时的区间端点可能前面的比后面的大: //2:优化:因为每次更新都是开平方,同一个数更新有限次数就一直是1了,所以可以这样优化 #include <stdio.h> #include<math.h> #define N 100010 #define LL __int64 #define lson l,m,rt<<1 #define rson

HDU 1556 Color the ball(线段树:区间更新)

http://acm.hdu.edu.cn/showproblem.php?pid=1556 题意: N个气球,每次[a,b]之间的气球涂一次色,统计每个气球涂色的次数. 思路: 这道题目用树状数组和线段树都可以,拿这道题来入门一下线段树的区间更新. 1 #include<iostream> 2 #include<cstring> 3 #include<algorithm> 4 using namespace std; 5 6 const int maxn = 1000

HDU 4902 线段树(区间更新)

Nice boat Time Limit: 30000/15000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 353    Accepted Submission(s): 169 Problem Description There is an old country and the king fell in love with a devil. The devil alw

CodeForces 52C Circular RMQ(区间循环线段树,区间更新,区间求和)

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://codeforces.com/problemset/problem/52/C You are given circular array a0,?a1,?...,?an?-?1. There are two types of operations with it: inc(lf,?rg,?v) - this operation increases each element on the segm

杭电1698--Just a Hook(线段树, 区间更新)

题目:http://acm.hdu.edu.cn/showproblem.php?pid=1698 线段树, 区间更新, 用到了Lazy思想.利用已更新区间来减少未更新区间用时.(自己的理解, 应该是对的) #include <cstdio>#include <cstring>#include <iostream>using namespace std;int Node[100100<<2], n, m, lazy[100100<<2];void

FZU Problem 2171 防守阵地 II (线段树,区间更新)

 Problem 2171 防守阵地 II Accept: 143    Submit: 565Time Limit: 3000 mSec    Memory Limit : 32768 KB  Problem Description 部队中总共有N个士兵,每个士兵有各自的能力指数Xi,在一次演练中,指挥部确定了M个需要防守的地点,指挥部将选择M个士兵依次进入指定地点进行防守任务,获得的参考指数即为M个士兵的能力之和.随着时间的推移,指挥部将下达Q个指令来替换M个进行防守的士兵们,每个参加完防守

poj 2777 线段树的区间更新

Count Color Time Limit: 1000 MS Memory Limit: 65536 KB 64-bit integer IO format: %I64d , %I64u Java class name: Main [Submit] [Status] [Discuss] Description Chosen Problem Solving and Program design as an optional course, you are required to solve al

hdu 1556:Color the ball(线段树,区间更新,经典题)

Color the ball Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 7941    Accepted Submission(s): 4070 Problem Description N个气球排成一排,从左到右依次编号为1,2,3....N.每次给定2个整数a b(a <= b),lele便为骑上他的"小飞鸽"牌电

hdu 1698:Just a Hook(线段树,区间更新)

Just a Hook Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 15129    Accepted Submission(s): 7506 Problem Description In the game of DotA, Pudge's meat hook is actually the most horrible thing f